diff --git a/server/src/main/java/cz/zcu/yamanager/domain/VacationDay.java b/server/src/main/java/cz/zcu/yamanager/domain/VacationDay.java
index 0c9457e..3184594 100644
--- a/server/src/main/java/cz/zcu/yamanager/domain/VacationDay.java
+++ b/server/src/main/java/cz/zcu/yamanager/domain/VacationDay.java
@@ -1,139 +1,307 @@
 package cz.zcu.yamanager.domain;
 
+import cz.zcu.yamanager.dto.Status;
+import cz.zcu.yamanager.dto.VacationType;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+import javax.naming.OperationNotSupportedException;
 import java.time.LocalDate;
+import java.time.LocalDateTime;
 import java.time.LocalTime;
 
 /**
- * A domain class {@code VacationDay} represents a single record in the Vacation_day table of a database.
- * Class holds informations of a vacation day taken by a user.
+ * The domain class {@code VacationDay} represents a single record in the 'vacation_day' table of a database.
+ * Class holds informations of an overtime or a sick day taken by a user.
  */
 public class VacationDay {
+    /**
+     * The logger.
+     */
+    private static final Logger log = LoggerFactory.getLogger(VacationDay.class);
 
     /**
-     * ID of the vacation day.
+     * The ID of this vacation.
      */
     private final int id;
 
     /**
-     * Date of the vacation day.
+     * The date of this vacation.
      */
     private LocalDate date;
 
     /**
-     * Starting time of a vacation.
+     * The starting time of this vacation.
      */
     private LocalTime from;
 
     /**
-     * Ending time of a vacation.
+     * The ending time of this vacation.
      */
     private LocalTime to;
 
     /**
-     * Approval status of the vacation day.
+     * The date and time of a creation of this vacation.
+     */
+    private final LocalDateTime creationDate;
+
+    /**
+     * The approval status of this vacation.
      */
     private Status status;
 
     /**
-     * Creates a new instance of the class {@code VacationDay}.
-     * @param id ID of the vacation day.
-     * @param date Date of the vacation day.
-     * @param from Starting time of a vacation.
-     * @param to Ending time of a vacation.
-     * @param status Approval status of the vacation day.
+     * The type of this vacation.
+     */
+    private VacationType type;
+
+    /**
+     * Creates an empty vacation for testing purposes only.
+     * It just sets id to zero and creation date to nowte.
      */
-    public VacationDay(int id, LocalDate date, LocalTime from, LocalTime to, Status status) {
+    public VacationDay() {
+        VacationDay.log.trace("Creating a new instance of the class VacationDay.");
+        this.id = 0;
+        this.creationDate = LocalDateTime.now();
+    }
+
+    /**
+     * Creates a new sick day with the specified id, date, date when a sick day request was created and its approval status.
+     *
+     * @param id           the ID of the sick day
+     * @param date         the date of the sick day
+     * @param creationDate the date and time of the creation of the sick day
+     * @param status       the approval status of the sick day
+     */
+    public VacationDay(final int id, final LocalDate date, final LocalDateTime creationDate, final Status status) {
+        this(id, date, null, null, creationDate, status, VacationType.SICKDAY);
+    }
+
+    /**
+     * Creates a new overtime with the specified id, date, starting time, ending time, date when an overtime request was created and its approval status.
+     *
+     * @param id           the ID of the overtime
+     * @param date         the date of the overtime
+     * @param from         the starting time of the overtime
+     * @param to           the ending time of the overtime
+     * @param creationDate the date and time of the creation of the overtime
+     * @param status       the approval status of the overtime
+     */
+    public VacationDay(final int id, final LocalDate date, final LocalTime from, final LocalTime to, final LocalDateTime creationDate, final Status status) {
+        this(id, date, from, to, creationDate, status, VacationType.VACATION);
+    }
+
+    /**
+     * Creates a new overtime or sick day with all attributes.
+     *
+     * @param id           the ID of a vacation
+     * @param date         the date of a vacation
+     * @param from         the starting time of a vacation
+     * @param to           the ending time of a vacation
+     * @param creationDate the date and time of a creation of a vacation
+     * @param status       the approval status of a vacation
+     * @param type         the type of a vacation
+     */
+    private VacationDay(final int id, final LocalDate date, final LocalTime from, final LocalTime to, final LocalDateTime creationDate, final Status status, final VacationType type) {
+        VacationDay.log.trace("Creating a new instance of the class VacationDay.");
+        VacationDay.log.debug("VacationDay: id={},\ndate={},\nfrom={},\nto={},\ncreationDate={},\nstatus={},\ntype={}", id, date, from, to, creationDate, status, type);
+
         this.id = id;
         this.date = date;
-        this.from = from;
-        this.to = to;
+        this.setTime(from, to);
+        this.creationDate = creationDate;
         this.status = status;
+        this.type = type;
     }
 
     /**
-     * Gets an ID of the vacation day.
-     * @return The ID of the vacation day.
+     * Returns the ID of this vacation.
+     *
+     * @return the ID of this vacation
      */
     public int getId() {
-        return id;
+        return this.id;
     }
 
     /**
-     * Gets a date of the vacation day.
-     * @return The date of the vacation day.
+     * Returns the date of this vacation.
+     *
+     * @return the date of this vacation
      */
     public LocalDate getDate() {
-        return date;
+        return this.date;
     }
 
     /**
-     * Sets a new date.
-     * @param date The new date.
+     * Replaces the date of this vacation with the specified date.
+     *
+     * @param date the new date
      */
-    public void setDate(LocalDate date) {
+    public void setDate(final LocalDate date) {
+        VacationDay.log.debug("Settings a new value of a date: {}", date);
         this.date = date;
     }
 
     /**
-     * Gets a starting time of a vacation.
-     * @return The starting time of a vacation.
+     * Returns the starting time of this vacation.
+     *
+     * @return the starting time of this vacation
      */
     public LocalTime getFrom() {
-        return from;
+        return this.from;
     }
 
     /**
-     * Sets a new starting time.
-     * @param from The new starting time.
+     * Replaces the starting time of this vacation with the given time.
+     * If the given time is later or equals the ending time of this vacation the method throws an exception.
+     *
+     * @param from the new starting time
+     * @throws IllegalArgumentException when the given time is later or equals the ending time of this vacation
      */
-    public void setFrom(LocalTime from) {
+    public void setFrom(final LocalTime from) throws IllegalArgumentException {
+        VacationDay.log.debug("Settings a new value of the starting time of this vacation: {}", from);
+
+        if(this.type == VacationType.SICKDAY) {
+            VacationDay.log.info("The sick day must not have a starting time.");
+            this.from = null;
+        }
+
+        if (this.to != null && from.compareTo(this.to) >= 0) {
+            VacationDay.log.warn("The vacation must not start after it ends. from={}, to={}", from, this.to);
+            throw new IllegalArgumentException("time.order.error");
+        }
+
         this.from = from;
     }
 
     /**
-     * Gets an ending time of a vacation.
-     * @return The ending time of a vacation.
+     * Returns the ending time of this vacation.
+     *
+     * @return the ending time of this vacation
      */
     public LocalTime getTo() {
-        return to;
+        return this.to;
     }
 
     /**
-     * Sets a new ending time.
-     * @param to The new ending time.
+     * Replaces the ending time of this vacation with the provided time.
+     * If the given time is earlier or equals the starting time of this vacation the method throws an exception.
+     *
+     * @param to the new ending time
+     * @throws IllegalArgumentException when the given time is earlier or equals the starting time of this vacation
      */
-    public void setTo(LocalTime to) {
+    public void setTo(final LocalTime to) throws IllegalArgumentException {
+        VacationDay.log.debug("Settings a new value of the ending time of this vacation: {}", to);
+
+        if(this.type == VacationType.SICKDAY) {
+            VacationDay.log.info("The sick day must not have an ending time.");
+            this.to = null;
+        }
+
+        if (this.from != null && to.compareTo(this.from) <= 0) {
+            VacationDay.log.warn("The vacation must not end after it starts. from={}, to={}", this.from, to);
+            throw new IllegalArgumentException("time.order.error");
+        }
+
         this.to = to;
     }
 
     /**
-     * Gets an approval status of the vacation day.
-     * @return The approval status of the vacation day.
+     * Replaces the starting and ending time of this vacation with the provided values.
+     * If the starting time is later or equals the ending time the method throws an exception.
+     *
+     * @param from the new starting time
+     * @param to   the new ending time
+     * @throws IllegalArgumentException when the ending time is earlier or equals the starting time
+     */
+    public void setTime(final LocalTime from, final LocalTime to) throws IllegalArgumentException {
+        VacationDay.log.debug("Settings a new value of the starting {} and the ending {} time of this vacation.", from, to);
+
+        if(this.type == VacationType.SICKDAY) {
+            VacationDay.log.info("The sick day must not have a starting and an ending time.");
+            this.from = null;
+            this.to = null;
+        }
+
+        if (from.compareTo(to) >= 0) {
+            VacationDay.log.warn("The vacation must not start after it ends. from={}, to={}", from, to);
+            throw new IllegalArgumentException("time.order.error");
+        }
+
+        this.from = from;
+        this.to = to;
+    }
+
+    /**
+     * Returns the date and time of a creation of this vacation.
+     *
+     * @return the date and time of the creation of this vacation
+     */
+    public LocalDateTime getCreationDate() {
+        return this.creationDate;
+    }
+
+    /**
+     * Returns the approval status of this vacation.
+     *
+     * @return the approval status of this vacation
      */
     public Status getStatus() {
-        return status;
+        return this.status;
     }
 
     /**
-     * Sets a new approval status.
-     * @param status The new approval status.
+     * Replaces the approval status of this vacation with the given value.
+     *
+     * @param status the new approval status
      */
-    public void setStatus(Status status) {
+    public void setStatus(final Status status) {
+        VacationDay.log.debug("Setting a new approval status: {}", status);
         this.status = status;
     }
 
     /**
-     * Gets a string representation of the class {@code VacationDay}.
-     * @return The string representation of the class.
+     * Returns the type of this vacation.
+     *
+     * @return the type of this vacation
+     */
+    public VacationType getType() {
+        return this.type;
+    }
+
+    /**
+     * Replaces the type of this vacation with the handed type.
+     * If the given type is a SICKDAY the method sets the starting and the ending time to null.
+     *
+     * @param type the new type
+     */
+    public void setType(final VacationType type) {
+        VacationDay.log.debug("Setting a new type of this vacation: {}", type);
+
+        if(type == VacationType.SICKDAY) {
+            VacationDay.log.info("The sick day must not have a starting and an ending time.");
+            this.from = null;
+            this.to = null;
+        }
+
+        this.type = type;
+    }
+
+    /**
+     * Gets a string representation of this vacation. The representation consists of its id, date, starting time, ending time, creation date, status and type.
+     *
+     * @return the string representation of this vacation
      */
     @Override
     public String toString() {
         return "VacationDay{" +
-                "id=" + id +
-                ", date=" + date +
-                ", from=" + from +
-                ", to=" + to +
-                ", status=" + status +
+                "id=" + this.id +
+                ", date=" + this.date +
+                ", from=" + this.from +
+                ", to=" + this.to +
+                ", creationDate=" + this.creationDate +
+                ", status=" + this.status +
+                ", type=" + this.type +
                 '}';
     }
 }
diff --git a/server/src/main/java/cz/zcu/yamanager/dto/AuthorizationRequest.java b/server/src/main/java/cz/zcu/yamanager/dto/AuthorizationRequest.java
index 1b0b169..10ccc99 100644
--- a/server/src/main/java/cz/zcu/yamanager/dto/AuthorizationRequest.java
+++ b/server/src/main/java/cz/zcu/yamanager/dto/AuthorizationRequest.java
@@ -2,51 +2,124 @@ package cz.zcu.yamanager.dto;
 
 import java.time.LocalDateTime;
 
+/**
+ * An instance of the messenger class {@code AuthorizationRequest} is just a different view of a user.
+ * It stores information relevant to a user's authorization in the application.
+ * This class is used to communication with a frontend.
+ */
 public class AuthorizationRequest {
-
+    /**
+     * The user's ID.
+     */
     private Long id;
+
+    /**
+     * The user's first name.
+     */
     private String firstName;
+
+    /**
+     * The user's last name.
+     */
     private String lastName;
+
+    /**
+     * The user's authorization status.
+     */
     private Status status;
+
+    /**
+     * The date and time of a creation of this request.
+     */
     private LocalDateTime timestamp;
 
+    /**
+     * Returns the user's ID.
+     *
+     * @return the user's ID
+     */
     public Long getId() {
-        return id;
+        return this.id;
     }
 
-    public void setId(Long id) {
+    /**
+     * Replaces the user's ID with the specified value.
+     *
+     * @param id the new user's ID
+     */
+    public void setId(final Long id) {
         this.id = id;
     }
 
+    /**
+     * Returns the user's first name.
+     *
+     * @return the user's first name
+     */
     public String getFirstName() {
-        return firstName;
+        return this.firstName;
     }
 
-    public void setFirstName(String firstName) {
+    /**
+     * Replaces the user's first name with the new specified value.
+     *
+     * @param firstName the new first name
+     */
+    public void setFirstName(final String firstName) {
         this.firstName = firstName;
     }
 
+    /**
+     * Returns the user's last name.
+     *
+     * @return the user's last name
+     */
     public String getLastName() {
-        return lastName;
+        return this.lastName;
     }
 
-    public void setLastName(String lastName) {
+    /**
+     * Replaces the user's last name with the given one.
+     *
+     * @param lastName the new last name
+     */
+    public void setLastName(final String lastName) {
         this.lastName = lastName;
     }
 
+    /**
+     * Returns the user's authorization status.
+     *
+     * @return the user's authorization status
+     */
     public Status getStatus() {
-        return status;
+        return this.status;
     }
 
-    public void setStatus(Status status) {
+    /**
+     * Replaces the authorization status with the handed value.
+     *
+     * @param status the new authorization status
+     */
+    public void setStatus(final Status status) {
         this.status = status;
     }
 
+    /**
+     * Returns the date and time of a creation of this user's request.
+     *
+     * @return the date and time of the creation of this user's request
+     */
     public LocalDateTime getTimestamp() {
-        return timestamp;
+        return this.timestamp;
     }
 
-    public void setTimestamp(LocalDateTime timestamp) {
+    /**
+     * Replaces the date and time of a creation of this user's request with the given value.
+     *
+     * @param timestamp the new date and time of the creation of this user's request
+     */
+    public void setTimestamp(final LocalDateTime timestamp) {
         this.timestamp = timestamp;
     }
 }
diff --git a/server/src/main/java/cz/zcu/yamanager/dto/BasicProfileUser.java b/server/src/main/java/cz/zcu/yamanager/dto/BasicProfileUser.java
index e062a83..37e95a8 100644
--- a/server/src/main/java/cz/zcu/yamanager/dto/BasicProfileUser.java
+++ b/server/src/main/java/cz/zcu/yamanager/dto/BasicProfileUser.java
@@ -2,50 +2,124 @@ package cz.zcu.yamanager.dto;
 
 import java.util.List;
 
+/**
+ * An instance of the messenger class {@code BasicProfileUser} represents a basic profile of a user in a database.
+ * The basic profile contains default, the most important informations which helps identify a user like a name or photo.
+ * This class is used to communicate with a frontend.
+ */
 public class BasicProfileUser {
+    /**
+     * The user's ID.
+     */
     private Long id;
+
+    /**
+     * The user's first name.
+     */
     private String firstName;
+
+    /**
+     * The user's last name.
+     */
     private String lastName;
+
+    /**
+     * The URL of a user's photo.
+     */
     private String photo;
+
+    /**
+     * The list of user's vacations.
+     */
     private List<VacationDay> calendar;
 
+    /**
+     * Returns the user's ID.
+     *
+     * @return the user's ID
+     */
     public Long getId() {
-        return id;
+        return this.id;
     }
 
-    public void setId(Long id) {
+    /**
+     * Replaces the user's ID with the specified value.
+     *
+     * @param id the new user's ID
+     */
+    public void setId(final Long id) {
         this.id = id;
     }
 
+    /**
+     * Returns the user's first name.
+     *
+     * @return the user's first name
+     */
     public String getFirstName() {
-        return firstName;
+        return this.firstName;
     }
 
-    public void setFirstName(String firstName) {
+    /**
+     * Replaces the user's first name with the new specified value.
+     *
+     * @param firstName the new first name
+     */
+    public void setFirstName(final String firstName) {
         this.firstName = firstName;
     }
 
+    /**
+     * Returns the user's last name.
+     *
+     * @return the user's last name
+     */
     public String getLastName() {
-        return lastName;
+        return this.lastName;
     }
 
-    public void setLastName(String lastName) {
+    /**
+     * Replaces the user's last name with the given one.
+     *
+     * @param lastName the new last name
+     */
+    public void setLastName(final String lastName) {
         this.lastName = lastName;
     }
 
+    /**
+     * Returns the URL of a user's photo.
+     *
+     * @return the URL of the user's photo
+     */
     public String getPhoto() {
-        return photo;
+        return this.photo;
     }
 
-    public void setPhoto(String photo) {
+    /**
+     * Replaces the URL of a user's photo with the given link.
+     *
+     * @param photo the new URL of the user's photo
+     */
+    public void setPhoto(final String photo) {
         this.photo = photo;
     }
 
+    /**
+     * Returns the list of user's vacations.
+     *
+     * @return the list of user's vacations
+     */
     public List<VacationDay> getCalendar() {
-        return calendar;
+        return this.calendar;
     }
 
-    public void setCalendar(List<VacationDay> calendar) {
+    /**
+     * Replaces the list of user's vacations with the given list.
+     *
+     * @param calendar the new list of vacations
+     */
+    public void setCalendar(final List<VacationDay> calendar) {
         this.calendar = calendar;
     }
 }
diff --git a/server/src/main/java/cz/zcu/yamanager/dto/BasicRequest.java b/server/src/main/java/cz/zcu/yamanager/dto/BasicRequest.java
index 11a16b9..2eaa11e 100644
--- a/server/src/main/java/cz/zcu/yamanager/dto/BasicRequest.java
+++ b/server/src/main/java/cz/zcu/yamanager/dto/BasicRequest.java
@@ -1,23 +1,54 @@
 package cz.zcu.yamanager.dto;
 
+/**
+ * An instance of the messenger class {@code BasicRequest} can represent an authorization or a vacation request.
+ * The class is used for changing a status of the authorization or the vacation request when a client sends a request on an api endpoint.
+ * This class is used to communicate with a frontend.
+ */
 public class BasicRequest {
-
+    /**
+     * The ID of this request.
+     */
     private Long id;
+
+    /**
+     * The approval/authorization status of this request.
+     */
     private Status status;
 
+    /**
+     * Returns the ID of this request.
+     *
+     * @return the ID of this request
+     */
     public Long getId() {
-        return id;
+        return this.id;
     }
 
-    public void setId(Long id) {
+    /**
+     * Replaces the user's ID with the specified value.
+     *
+     * @param id the new user's ID
+     */
+    public void setId(final Long id) {
         this.id = id;
     }
 
+    /**
+     * Returns the approval/authorization status of this request.
+     *
+     * @return the approval status of this vacation
+     */
     public Status getStatus() {
-        return status;
+        return this.status;
     }
 
-    public void setStatus(Status status) {
+    /**
+     * Replaces the approval/authorization status of this request with the given value.
+     *
+     * @param status the new approval/authorization status
+     */
+    public void setStatus(final Status status) {
         this.status = status;
     }
 }
diff --git a/server/src/main/java/cz/zcu/yamanager/dto/DefaultSettings.java b/server/src/main/java/cz/zcu/yamanager/dto/DefaultSettings.java
index b84fdd4..c6983fe 100644
--- a/server/src/main/java/cz/zcu/yamanager/dto/DefaultSettings.java
+++ b/server/src/main/java/cz/zcu/yamanager/dto/DefaultSettings.java
@@ -2,24 +2,56 @@ package cz.zcu.yamanager.dto;
 
 import java.time.LocalDateTime;
 
+/**
+ * The messenger class {@code DefaultSettings} contains default settings of users' informations that are known to the application.
+ * Informations consist of a number of available sick days, date and time of an email notification.
+ * Default settings are mainly used when the user is added to the application which means he/she can't have his/her own values.
+ * This class is used to communicate with a frontend.
+ */
 public class DefaultSettings {
-
-    private Integer sickdayCount;
+    /**
+     * The default number of available sick days.
+     */
+    private Integer sickDayCount;
+
+    /**
+     * The default date and time of sending an email warning about an incoming reset of remaining overtimes and sick days.
+     */
     private LocalDateTime notification;
 
-    public Integer getSickdayCount() {
-        return sickdayCount;
+    /**
+     * Returns the default number of available sick days in this default settings.
+     *
+     * @return the default number of available sick days
+     */
+    public Integer getSickDayCount() {
+        return this.sickDayCount;
     }
 
-    public void setSickdayCount(Integer sickdayCount) {
-        this.sickdayCount = sickdayCount;
+    /**
+     * Replaces the default number of available sick days in this default settings with the given one.
+     *
+     * @param sickDayCount the new default number of available sick days
+     */
+    public void setSickDayCount(final Integer sickDayCount) {
+        this.sickDayCount = sickDayCount;
     }
 
+    /**
+     * Returns the default date and time of sending an email warning about an incoming reset of remaining overtimes and sick days.
+     *
+     * @return the default date and time
+     */
     public LocalDateTime getNotification() {
-        return notification;
+        return this.notification;
     }
 
-    public void setNotification(LocalDateTime notification) {
+    /**
+     * Replaces the default date and time of sending an email warning about an incoming reset of remaining overtimes and sick days with the specified one.
+     *
+     * @param notification the new default date and time
+     */
+    public void setNotification(final LocalDateTime notification) {
         this.notification = notification;
     }
 }
